Attribute VB_Name = "modLibrary"
'RUMINT, A PVR for network traffic
'Copyright (C) 2005 Greg Conti

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Option Explicit

Public Const MAXSYMBOLSINENCODING = 255 'for 8 bit ASCII
Public Const MAXPACKETBUFFER = 30000
Public Const MAXPACKETSIZE = 1600
Public Const BM_SETSTATE = &HF3

'Public MAXPACKETBUFFER As Long
'Public MAXPACKETSIZE as Long
Private packetCounter As Long
Private packetBufferIndex As Long
Private numPackets As Long
Private packetBuffer() As Long          'declared dynamically so it can be redimensioned by user
Private packetLenBuffer() As Long

Private packetEtherType() As Long

Private packetIPtransportProtocol() As Long
Private packetIPsource() As Long
Private packetIPdest() As Long
Private packetIPTTL() As Long
Private packetIPHeaderLen() As Long
Private packetIPVersion() As Long

Private packetIPDifferentiatedServices() As Long
Private packetIPlength() As Long
Private packetIPidentification() As Long
Private packetIPchecksum() As Long
Private packetIPfragmentoffset() As Long
Private packetIPflagsR() As Boolean
Private packetIPflagsDF() As Boolean
Private packetIPflagsMF() As Boolean
  
Private packetUDPsourcePort() As Long
Private packetUDPdestPort() As Long
Private packetTCPsourcePort() As Long
Private packetTCPdestPort() As Long
Private packetTCPsequencenumber() As Long

Public packetByteFrequency() As Single 'holds the byte frequency of a single packet
Public packetAverageByteFrequency As Single 'hold the average byte frequency of a single packet

'use this function to change button state akin to toggle button
'but free from the dependency on the fm20 library
Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
                                 (ByVal hwnd As Long, _
                                  ByVal wMsg As Long, _
                                  ByVal wParam As Long, _
                                  ByVal lParam As Long) As Long


Public Function getBufferStartIndex()
  If packetBufferIndex = 0 Then getBufferStartIndex = 0
  If getNumPackets <= MAXPACKETBUFFER Then getBufferStartIndex = 1
  If getNumPackets > MAXPACKETBUFFER Then getBufferStartIndex = packetLocation2BufferIndex(1)
End Function

Public Function getBufferEndIndex() As Long
  getBufferEndIndex = packetBufferIndex
End Function

Public Function getNumPackets() As Long
  getNumPackets = numPackets
End Function

Public Function packetLocation2BufferIndex(ByVal packetlocation) As Long
  If getNumPackets <= MAXPACKETBUFFER Then
    packetLocation2BufferIndex = packetlocation
  Else
    If packetBufferIndex + 1 <= MAXPACKETBUFFER Then
      packetLocation2BufferIndex = packetBufferIndex + 1
    Else
      packetLocation2BufferIndex = 1
    End If
  End If
End Function



Private Sub updatePacketCounterVisualizations()
  frmFilters.lblPacketCounter = getPacketCounter
  frmFilters.lblPacketMax = getPacketCounter
  
  frmFilters.scrPacket.Tag = "locked" 'prevents dual triggering of change event
  frmFilters.scrPacket.Max = getPacketCounter
  If getNumPackets <= MAXPACKETBUFFER Then
    frmFilters.scrPacket.Min = 1
    frmFilters.lblPacketMin = 1
  Else
    frmFilters.scrPacket.Min = getPacketCounter - MAXPACKETBUFFER + 1
    frmFilters.lblPacketMin = getPacketCounter - MAXPACKETBUFFER + 1
  End If
  frmFilters.scrPacket.Tag = "" 'prevents dual triggering of change event
    
  'frmFilters.lblBufferMaxBig.Caption = getBufferEndIndex()
  'frmFilters.lblBufferMinBig.Caption = getBufferStartIndex()
End Sub

Public Function putPacket(packetData As Variant, packetLen As Long) As Long 'returns position in buffer
  Dim counter As Long
  numPackets = numPackets + 1
  If modLibrary.packetBufferIndex < MAXPACKETBUFFER Then
    modLibrary.packetBufferIndex = modLibrary.packetBufferIndex + 1
  Else
    modLibrary.packetBufferIndex = 1
  End If
  For counter = 0 To packetLen
    modLibrary.packetBuffer(modLibrary.packetBufferIndex, counter) = packetData(counter)
  Next counter
  modLibrary.packetLenBuffer(modLibrary.packetBufferIndex) = packetLen
  Call modProcess.dissect(modLibrary.packetBufferIndex, packetData, packetLen)
  incrementPacketCounter
  updatePacketCounterVisualizations
  putPacket = modLibrary.packetBufferIndex 'keep this at end
End Function

Public Function getPacketLen(ByVal packetlocation As Long) As Long
  'getPacketLen = packetLenBuffer(packetlocation)
  getPacketLen = packetLenBuffer(packetLocation2BufferIndex(packetlocation))
End Function

Private Sub incrementPacketCounter()
  packetCounter = packetCounter + 1
End Sub

Public Function getPacketCounter() As Long
  getPacketCounter = packetCounter
End Function

Public Function getPacketByte(ByVal packetlocation As Long, ByVal packetByte As Long) As Long
  'getPacketByte = packetBuffer(packetlocation, packetByte)
  getPacketByte = packetBuffer(packetLocation2BufferIndex(packetlocation), packetByte)
End Function

Public Sub setEtherType(ByVal packetlocation As Long, ByVal value1 As Long, ByVal value2 As Long)
  packetEtherType(packetLocation2BufferIndex(packetlocation), 1) = value1
  packetEtherType(packetLocation2BufferIndex(packetlocation), 2) = value2
End Sub

Public Function getEtherType(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetEtherType(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetEtherType(packetLocation2BufferIndex(packetlocation), 2)
  'getEtherType = (((packetEtherType(packetlocation, 1) / 2) * 2) * 256) + (packetEtherType(packetlocation, 2))
  getEtherType = (octet1 * 256) + octet2
End Function

Public Function getEtherTypeString(ByVal packetlocation As Long) As String
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetEtherType(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetEtherType(packetLocation2BufferIndex(packetlocation), 2)
  getEtherTypeString = "0x" & Hex((octet1 * 256) + octet2)
  'getEtherTypeString = "0x" & Hex((((packetEtherType(packetlocation, 1) / 2) * 2) * 256) + (packetEtherType(packetlocation, 2)))
End Function


'see http://www.iana.org/assignments/protocol-numbers
Public Function getPacketIPtransportProtocol(ByVal packetlocation As Long) As Long
  getPacketIPtransportProtocol = packetIPtransportProtocol(packetLocation2BufferIndex(packetlocation))
End Function

Public Sub setPacketIPtransportProtocol(ByVal packetlocation As Long, ByVal value As Long)
  packetIPtransportProtocol(packetLocation2BufferIndex(packetlocation)) = value
End Sub

Public Function getIPTTL(ByVal packetlocation As Long) As Long
  getIPTTL = packetIPTTL(packetLocation2BufferIndex(packetlocation))
End Function

Public Sub setIPTTL(ByVal packetlocation As Long, ByVal value As Long)
  packetIPTTL(packetLocation2BufferIndex(packetlocation)) = value
End Sub

Public Function getIPVersion(ByVal packetlocation As Long) As Long
  getIPVersion = packetIPVersion(packetLocation2BufferIndex(packetlocation))
End Function

Public Sub setDifferentiatedServices(ByVal packetlocation As Long, ByVal value As Long)
  packetIPDifferentiatedServices(packetLocation2BufferIndex(packetlocation)) = value
End Sub

Public Function getDifferentiatedServices(ByVal packetlocation As Long) As Long
  getDifferentiatedServices = packetIPDifferentiatedServices(packetLocation2BufferIndex(packetlocation))
End Function

Public Sub setIPtotalLength(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  packetIPlength(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetIPlength(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub

Public Function getIPtotalLength(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetIPlength(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetIPlength(packetLocation2BufferIndex(packetlocation), 2)
  getIPtotalLength = (octet1 * 256) + octet2
  'getIPtotalLength = (((packetIPlength(packetlocation, 1) / 2) * 2) * 256) + (packetIPlength(packetlocation, 2))
End Function

Public Function getIPidentification(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetIPidentification(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetIPidentification(packetLocation2BufferIndex(packetlocation), 2)
  getIPidentification = (octet1 * 256) + octet2
  'getIPidentification = (((packetIPidentification(packetlocation, 1) / 2) * 2) * 256) + (packetIPidentification(packetlocation, 2))
End Function

Public Sub setIPidentification(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  packetIPidentification(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetIPidentification(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub

Public Function getIPheaderchecksum(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetIPchecksum(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetIPchecksum(packetLocation2BufferIndex(packetlocation), 2)
  getIPheaderchecksum = (octet1 * 256) + octet2
  'getIPheaderchecksum = (((packetIPchecksum(packetlocation, 1) / 2) * 2) * 256) + (packetIPchecksum(packetlocation, 2))
End Function

Public Sub setIPheaderchecksum(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  packetIPchecksum(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetIPchecksum(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub

Public Sub setIPFlags(ByVal packetlocation As Long, ByVal value As Long) 'first three bits!!!
  Dim IPFlags As Long
  'extract IP flags, the first three
  If (value And 128) Then packetIPflagsR(packetLocation2BufferIndex(packetlocation)) = True Else packetIPflagsR(packetLocation2BufferIndex(packetlocation)) = False
  If (value And 64) Then packetIPflagsDF(packetLocation2BufferIndex(packetlocation)) = True Else packetIPflagsDF(packetLocation2BufferIndex(packetlocation)) = False
  If (value And 32) Then packetIPflagsMF(packetLocation2BufferIndex(packetlocation)) = True Else packetIPflagsMF(packetLocation2BufferIndex(packetlocation)) = False
End Sub
  
Public Function getIPflagsR(ByVal packetlocation As Long) As Boolean
  getIPflagsR = packetIPflagsR(packetLocation2BufferIndex(packetlocation))
End Function
  
Public Function getIPflagsDF(ByVal packetlocation As Long) As Boolean
  getIPflagsDF = packetIPflagsDF(packetLocation2BufferIndex(packetlocation))
End Function
  
Public Function getIPflagsMF(ByVal packetlocation As Long) As Boolean
  getIPflagsMF = packetIPflagsMF(packetLocation2BufferIndex(packetlocation))
End Function
  
  
Public Sub setIPfragmentOffset(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  'extract IP fragment offset, last five bits
  '31 = 00011111 used as bitmask
  packetIPfragmentoffset(packetLocation2BufferIndex(packetlocation), 1) = 31 And octet1
  packetIPfragmentoffset(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub
  
Public Function getIPfragmentoffset(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetIPfragmentoffset(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetIPfragmentoffset(packetLocation2BufferIndex(packetlocation), 2)
  getIPfragmentoffset = (octet1 * 256) + octet2
  'getIPfragmentoffset = (((packetIPfragmentoffset(packetlocation, 1) / 2) * 2) * 256) + (packetIPfragmentoffset(packetlocation, 2))
End Function


Public Sub setIPVersion(ByVal packetlocation As Long, ByVal value As Long)
  Dim IPversion As Long
  'extract IP version, the first four bits
  If (value And 128) Then
   IPversion = IPversion + 8
  End If
  If (value And 64) Then
    IPversion = IPversion + 4
  End If
  If (value And 32) Then
    IPversion = IPversion + 2
  End If
  If (value And 16) Then
    IPversion = IPversion + 1
  End If
  packetIPVersion(packetLocation2BufferIndex(packetlocation)) = IPversion
End Sub

Public Function getIPHeaderLen(ByVal packetlocation As Long) As Long
  getIPHeaderLen = packetIPHeaderLen(packetLocation2BufferIndex(packetlocation))
End Function

Public Sub setIPHeaderLen(ByVal packetlocation As Long, ByVal value As Long)
  'extract ip header length, last four bits of field 14
  '15 = 00001111 used as bitmask
  packetIPHeaderLen(packetLocation2BufferIndex(packetlocation)) = 15 And value
End Sub

Public Function getSourceIP(ByVal packetlocation As Long, ByVal octet As Long) As Long
   getSourceIP = packetIPsource(packetLocation2BufferIndex(packetlocation), octet)
End Function

Public Function getSourceIPstring(ByVal packetlocation As Long) As String
  getSourceIPstring = packetIPsource(packetLocation2BufferIndex(packetlocation), 1) & "." & _
                 packetIPsource(packetLocation2BufferIndex(packetlocation), 2) & "." & _
                 packetIPsource(packetLocation2BufferIndex(packetlocation), 3) & "." & _
                 packetIPsource(packetLocation2BufferIndex(packetlocation), 4)
End Function

Public Sub setSourceIP(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long, _
                                               ByVal octet3 As Long, ByVal octet4 As Long)
  packetIPsource(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetIPsource(packetLocation2BufferIndex(packetlocation), 2) = octet2
  packetIPsource(packetLocation2BufferIndex(packetlocation), 3) = octet3
  packetIPsource(packetLocation2BufferIndex(packetlocation), 4) = octet4
End Sub
  
Public Function getDestIP(ByVal packetlocation As Long, ByVal octet As Long) As Long
  getDestIP = packetIPdest(packetLocation2BufferIndex(packetlocation), octet)
End Function
  
Public Function getDestIPstring(ByVal packetlocation As Long) As String
  getDestIPstring = packetIPdest(packetLocation2BufferIndex(packetlocation), 1) & "." & _
                 packetIPdest(packetLocation2BufferIndex(packetlocation), 2) & "." & _
                 packetIPdest(packetLocation2BufferIndex(packetlocation), 3) & "." & _
                 packetIPdest(packetLocation2BufferIndex(packetlocation), 4)
End Function
  
  
Public Sub setDestIP(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long, _
                                               ByVal octet3 As Long, ByVal octet4 As Long)
  packetIPdest(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetIPdest(packetLocation2BufferIndex(packetlocation), 2) = octet2
  packetIPdest(packetLocation2BufferIndex(packetlocation), 3) = octet3
  packetIPdest(packetLocation2BufferIndex(packetlocation), 4) = octet4
  
End Sub
  
Public Sub setUDPsourcePort(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  packetUDPsourcePort(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetUDPsourcePort(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub

Public Function getUDPsourcePort(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetUDPsourcePort(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetUDPsourcePort(packetLocation2BufferIndex(packetlocation), 2)
  getUDPsourcePort = (octet1 * 256) + octet2
  'getUDPsourcePort = (((packetUDPsourcePort(packetlocation, 1) / 2) * 2) * 256) + packetUDPsourcePort(packetlocation, 2)
End Function


Public Sub setTCPsourcePort(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  packetTCPsourcePort(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetTCPsourcePort(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub

Public Function getTCPsourcePort(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetTCPsourcePort(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetTCPsourcePort(packetLocation2BufferIndex(packetlocation), 2)
  getTCPsourcePort = (octet1 * 256) + octet2
  'getTCPsourcePort = (((packetTCPsourcePort(packetlocation, 1) / 2) * 2) * 256) + packetTCPsourcePort(packetlocation, 2)
End Function

Public Function getTCPsequencenumber(ByVal packetlocation As Long, ByVal octet As Long) As Long
  getTCPsequencenumber = packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), octet)
End Function
  
'This function takes single digit hex strings and prepends a leading zero
Private Function ShortHex2LongHex(ByVal hexString) As String
  If Len(hexString) = 1 Then ShortHex2LongHex = "0" & hexString Else ShortHex2LongHex = hexString
End Function
  
Public Function getTCPsequencenumberString(ByVal packetlocation As Long) As String
  getTCPsequencenumberString = "0x" & _
    ShortHex2LongHex(Hex(packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 1))) & _
    ShortHex2LongHex(Hex(packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 2))) & _
    ShortHex2LongHex(Hex(packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 3))) & _
    ShortHex2LongHex(Hex(packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 4)))
End Function
  
  
Public Sub setTCPsequencenumber(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long, _
                                               ByVal octet3 As Long, ByVal octet4 As Long)
  packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 2) = octet2
  packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 3) = octet3
  packetTCPsequencenumber(packetLocation2BufferIndex(packetlocation), 4) = octet4
  
End Sub



Public Sub setUDPdestPort(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  packetUDPdestPort(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetUDPdestPort(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub

Public Function getUDPdestPort(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetUDPdestPort(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetUDPdestPort(packetLocation2BufferIndex(packetlocation), 2)
  getUDPdestPort = (octet1 * 256) + octet2
  'getUDPdestPort = (((packetUDPdestPort(packetlocation, 1) / 2) * 2) * 256) + packetUDPdestPort(packetlocation, 2)
End Function

Public Sub setTCPdestPort(ByVal packetlocation As Long, ByVal octet1 As Long, ByVal octet2 As Long)
  packetTCPdestPort(packetLocation2BufferIndex(packetlocation), 1) = octet1
  packetTCPdestPort(packetLocation2BufferIndex(packetlocation), 2) = octet2
End Sub

Public Function getTCPdestPort(ByVal packetlocation As Long) As Long
  'beware multiplying directly from the arrays will cause an overflow error
  Dim octet1 As Long
  Dim octet2 As Long
  octet1 = packetTCPdestPort(packetLocation2BufferIndex(packetlocation), 1)
  octet2 = packetTCPdestPort(packetLocation2BufferIndex(packetlocation), 2)
  getTCPdestPort = (octet1 * 256) + octet2
 'getTCPdestPort = (((packetTCPdestPort(packetlocation, 1) / 2) * 2) * 256) + packetTCPdestPort(packetlocation, 2)
End Function

'Dynamically change the size of the buffer arrays
'use the preserve keywork if you want to retain contents
'The limit should be user's choice

Private Sub clearBuffer()
  packetBufferIndex = 0
  numPackets = 0
  packetCounter = 0
  
  frmFilters.lblPacketCounter.Caption = "0"
  
  ReDim packetBuffer(1 To MAXPACKETBUFFER, 0 To MAXPACKETSIZE)
  ReDim packetLenBuffer(1 To MAXPACKETBUFFER)
  
  ReDim packetEtherType(1 To MAXPACKETBUFFER, 1 To 2)
  
  ReDim packetIPtransportProtocol(1 To MAXPACKETBUFFER)
  ReDim packetIPsource(1 To MAXPACKETBUFFER, 1 To 4)
  ReDim packetIPdest(1 To MAXPACKETBUFFER, 1 To 4)
  ReDim packetIPTTL(1 To MAXPACKETBUFFER)
  ReDim packetIPHeaderLen(1 To MAXPACKETBUFFER)
  ReDim packetIPVersion(1 To MAXPACKETBUFFER)
  
  ReDim packetIPDifferentiatedServices(1 To MAXPACKETBUFFER)
  ReDim packetIPlength(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetIPidentification(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetIPchecksum(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetIPfragmentoffset(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetIPflagsR(1 To MAXPACKETBUFFER)
  ReDim packetIPflagsDF(1 To MAXPACKETBUFFER)
  ReDim packetIPflagsMF(1 To MAXPACKETBUFFER)
  
  
  ReDim packetUDPsourcePort(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetUDPdestPort(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetTCPsourcePort(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetTCPdestPort(1 To MAXPACKETBUFFER, 1 To 2)
  ReDim packetTCPsequencenumber(1 To MAXPACKETBUFFER, 1 To 4) As Long
  
  ReDim packetByteFrequency(0 To MAXSYMBOLSINENCODING)

End Sub

Public Sub initBuffer(state As String)
  Dim userChoice As Long
  
  If state = "startup" Then
    clearBuffer 'clear the buffer
  End If
  
  If numPackets > 0 And (state = "capture" Or state = "file") Then
    'userChoice = MsgBox("Packets exist in the buffer.  Do you wish to overwrite?", vbExclamation + vbYesNo, "Verify Buffer Delete")
    'If userChoice = vbYes Then
      clearBuffer 'clear the buffer
      modVisualize.clearAllVisualizationWindows
      updatePacketCounterVisualizations
    'End If
  End If
End Sub


Public Sub ToggleForm(ToggledForm As Form, CallingMenu As Object)
  If CallingMenu.Checked = False Then
    CallingMenu.Checked = True
    'Debug.Print CallingMenu
    'If ToggledForm.Tag = "vis1" Then ToggledForm.grayVisThumb
    'If ToggledForm.Tag = "vis2" Then ToggledForm.grayVisThumb
    ToggledForm.Show
    
    'If the form was minimized when it was deselected then make it normal
    If (ToggledForm.WindowState = 1) Then ToggledForm.WindowState = 0 'Normal
  Else
    CallingMenu.Checked = False
    ToggledForm.Hide
    If ToggledForm.Tag = "vis1" Then ToggledForm.initVisThumb
    If ToggledForm.Tag = "vis2" Then ToggledForm.initVisThumb
  End If
End Sub

Public Sub UnloadedForm(ToggledForm As Form, CallingMenu As Object)
  If CallingMenu.Checked = False Then
    CallingMenu.Checked = True
  Else
    CallingMenu.Checked = False
  End If
End Sub

'called when the program is exited
Public Sub ExitProgram()
  'put any cleanup code here
End 'ExitProgram
End Sub

'A simple min function
Public Function Min(value1 As Variant, value2 As Variant) As Variant
  If value1 < value2 Then Min = value1 Else Min = value2
End Function



Public Sub Timer(mode As String, numPackets As Long)
  Static startTime As Variant
  Dim endTime As Variant
  Dim elapsedTime As Variant
  
  If (mode = "start") Then
    startTime = Now
    'Debug.Print "Starting Timer at " & startTime
  Else
    If (mode = "stop") Then
      endTime = Now
      'Debug.Print "Stopping Timer at " & endTime
      elapsedTime = DateDiff("s", startTime, endTime)
      Debug.Print
      If elapsedTime > 0 Then Debug.Print "elapsed Time = " & elapsedTime & " packets = " & numPackets & "  packets per second = " & (numPackets / elapsedTime)
      Debug.Print
    End If
  End If
End Sub

